%%  Demo for FERRT with block-based missing entries.
 %  You may test other data such as YaleB in similar way.

load('Data\FERET\FERET_8060721.mat')
%% Feature Extraction Step
FaceSize=[size(fea3D,1) size(fea3D,2)];
N = 10;    % Repeat the run 10 times 
D = [40 30]; % Feature dimension 
MaxK = 20; % Maximum number of iterations 
mu0 = 5;   % Initial mu
epsilon= 1e-5; % Stopping tolerance tol
Fea_out=cell(1,N);
Time=zeros(1,N);

MissBlock={[5,10] [20 20] [40 30] [55 55]};
for iii=1:4
    strlbl2=['0412_FERET60_TDFEID_Block4_Miss',num2str(MissBlock{iii}(1)),num2str(MissBlock{iii}(2))];
    for TCrun=1:N
        [Fea_Miss] = BlockMissing(fea2D,FaceSize, MissBlock{iii});
        fea3D=reshape(Fea_Miss',size(Fea_Miss',1), FaceSize(1),FaceSize(2));
        T=permute(fea3D, [2 3 1]);
        
        for m=1:721
            Omega0= T(:,:,m)==1e-27;
            Omega(:,:,m)=1-Omega0;
            Omega(:,:,m)=logical(Omega(:,:,m));
        end
        Omega=logical(Omega);

        tic
        [ExtraFea] = TDVM(T, Omega, D,mu0,MaxK,epsilon);
        TimeTucker= toc
        Fea_out{TCrun}=ExtraFea;
        Time(TCrun)=TimeTucker;
    end
    Result.MeanTime(iii)= mean(Time);
    MeanFea0=zeros(size(ExtraFea));
    for i=1:N
        temp=  (Fea_out{i});
        MeanFea0=temp+ MeanFea0;
    end
    MeanFea=MeanFea0/N; % Average the extracted features
    
%% Classification Step
    for iTrn=1:7
        TrainTest=['Data\FERET\',num2str(iTrn), 'Train\'];
        numRand=10;
        for iRand= 1:numRand
            strlbl=[TrainTest,num2str(iRand)];
            load(strlbl);
            NNC_Turker=NNC(MeanFea,gnd,trainIdx,testIdx,[1:prod(D)],['TDVM']);
            MaxNNC_Tucker(iTrn,iRand)=max(NNC_Turker);
        end
        
    end
    Result.MeanResults(iii,:)=mean(MaxNNC_Tucker');
    %save(strlbl2, 'Result','-v7.3')
end
