load('Data\FERET\FERET_8060721.mat')
%% Feature Extraction Step
FaceSize=[size(fea3D,1) size(fea3D,2)];
N = 10; % Repeat the run 10 times 
D = [40 30]; % Feature dimension 
MaxK = 20; % Maximum number of iterations 
mu0 = 5;    %Initial mu0 
epsilon= 1e-5; % Stopping tolerance tol
Fea_out=cell(1,N);
Time=zeros(1,N);

%% Feature extraction step by TDVM 
MissRatio=[10 30 50 90]; % Pixel-based missing ratio
for iii = 4
    strlbl2=['0412_FERET_TDFEID_Pixel_Miss',num2str(MissRatio(iii))];
    for TCrun=1:N
  % Pixel-based missing setting 
        ObsRatio =1- MissRatio(iii)*0.01 %Observed ratio= 1- missing ratio 
        H = ones(size(fea3D));
        [n1, n2, n3] = size(fea3D);
        [I, J, K] = ind2sub([n1, n2, n3], find(H(:)));
        clear 'H';
        DIM = size(fea3D);
        data = fea3D(:);
        subs = double([I, J, K]);
        rp = randperm(length(data));
        traIdx=rp(1:round(ObsRatio*length(rp)));
        data_train = data(traIdx);
        T = zeros(size(fea3D));
        T(traIdx) = double(data(traIdx));
        Omega=T;
        Omega(traIdx)=1;
        Omega=logical(Omega);
        tic
        [ExtraFea] = TDVM(T, Omega, D,mu0,MaxK,epsilon);
        TimeTucker= toc; 
        Fea_out{TCrun}=ExtraFea;
        Time(TCrun)=TimeTucker;
    end
      Result.MeanTime(iii)= mean(Time); 
      MeanFea0=zeros(size(ExtraFea));
    for i=1:N
        temp=  (Fea_out{i});
        MeanFea0=temp+ MeanFea0;
    end
  MeanFea=MeanFea0/N; % Average the extracted features
    
%% Classification Step by NNC 
   for iTrn=[1 7]
     TrainTest=['D:\PhD-Y3\Codes_TCFE\TDVM_Demos\Data\FERET\',num2str(iTrn), 'Train\'];
     numRand=10;
        for iRand= 1:numRand
            strlbl=[TrainTest,num2str(iRand)];
            load(strlbl);
            NNC_Turker=NNC(MeanFea,gnd,trainIdx,testIdx,[1:prod(D)],['TDFEID']);
%             Result.ALLNNC_Tucker(:,iTrn,iRand)=NNC_Turker;
            MaxNNC_Tucker(iTrn,iRand)=max(NNC_Turker);
        end
    end
 Result.MeanResults(iii,:)=mean(MaxNNC_Tucker');
% save(strlbl2, 'Result','-v7.3')
end
